// https://www.terraform.io/docs/providers/google/d/compute_router_status.html
// generated from terraform resource schema

import { Construct } from 'constructs';
import * as cdktf from 'cdktf';

// Configuration

export interface DataGoogleComputeRouterStatusConfig extends cdktf.TerraformMetaArguments {
  /**
  * Name of the router to query.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/compute_router_status.html#name DataGoogleComputeRouterStatus#name}
  */
  readonly name: string;
  /**
  * Project ID of the target router.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/compute_router_status.html#project DataGoogleComputeRouterStatus#project}
  */
  readonly project?: string;
  /**
  * Region of the target router.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/compute_router_status.html#region DataGoogleComputeRouterStatus#region}
  */
  readonly region?: string;
}
export class DataGoogleComputeRouterStatusBestRoutes extends cdktf.ComplexComputedList {

  // description - computed: true, optional: false, required: false
  public get description() {
    return this.getStringAttribute('description');
  }

  // dest_range - computed: true, optional: false, required: false
  public get destRange() {
    return this.getStringAttribute('dest_range');
  }

  // name - computed: true, optional: false, required: false
  public get name() {
    return this.getStringAttribute('name');
  }

  // network - computed: true, optional: false, required: false
  public get network() {
    return this.getStringAttribute('network');
  }

  // next_hop_gateway - computed: true, optional: false, required: false
  public get nextHopGateway() {
    return this.getStringAttribute('next_hop_gateway');
  }

  // next_hop_ilb - computed: true, optional: false, required: false
  public get nextHopIlb() {
    return this.getStringAttribute('next_hop_ilb');
  }

  // next_hop_instance - computed: true, optional: false, required: false
  public get nextHopInstance() {
    return this.getStringAttribute('next_hop_instance');
  }

  // next_hop_instance_zone - computed: true, optional: false, required: false
  public get nextHopInstanceZone() {
    return this.getStringAttribute('next_hop_instance_zone');
  }

  // next_hop_ip - computed: true, optional: false, required: false
  public get nextHopIp() {
    return this.getStringAttribute('next_hop_ip');
  }

  // next_hop_network - computed: true, optional: false, required: false
  public get nextHopNetwork() {
    return this.getStringAttribute('next_hop_network');
  }

  // next_hop_vpn_tunnel - computed: true, optional: false, required: false
  public get nextHopVpnTunnel() {
    return this.getStringAttribute('next_hop_vpn_tunnel');
  }

  // priority - computed: true, optional: false, required: false
  public get priority() {
    return this.getNumberAttribute('priority');
  }

  // project - computed: true, optional: false, required: false
  public get project() {
    return this.getStringAttribute('project');
  }

  // self_link - computed: true, optional: false, required: false
  public get selfLink() {
    return this.getStringAttribute('self_link');
  }

  // tags - computed: true, optional: false, required: false
  public get tags() {
    return this.getListAttribute('tags');
  }
}
export class DataGoogleComputeRouterStatusBestRoutesForRouter extends cdktf.ComplexComputedList {

  // description - computed: true, optional: false, required: false
  public get description() {
    return this.getStringAttribute('description');
  }

  // dest_range - computed: true, optional: false, required: false
  public get destRange() {
    return this.getStringAttribute('dest_range');
  }

  // name - computed: true, optional: false, required: false
  public get name() {
    return this.getStringAttribute('name');
  }

  // network - computed: true, optional: false, required: false
  public get network() {
    return this.getStringAttribute('network');
  }

  // next_hop_gateway - computed: true, optional: false, required: false
  public get nextHopGateway() {
    return this.getStringAttribute('next_hop_gateway');
  }

  // next_hop_ilb - computed: true, optional: false, required: false
  public get nextHopIlb() {
    return this.getStringAttribute('next_hop_ilb');
  }

  // next_hop_instance - computed: true, optional: false, required: false
  public get nextHopInstance() {
    return this.getStringAttribute('next_hop_instance');
  }

  // next_hop_instance_zone - computed: true, optional: false, required: false
  public get nextHopInstanceZone() {
    return this.getStringAttribute('next_hop_instance_zone');
  }

  // next_hop_ip - computed: true, optional: false, required: false
  public get nextHopIp() {
    return this.getStringAttribute('next_hop_ip');
  }

  // next_hop_network - computed: true, optional: false, required: false
  public get nextHopNetwork() {
    return this.getStringAttribute('next_hop_network');
  }

  // next_hop_vpn_tunnel - computed: true, optional: false, required: false
  public get nextHopVpnTunnel() {
    return this.getStringAttribute('next_hop_vpn_tunnel');
  }

  // priority - computed: true, optional: false, required: false
  public get priority() {
    return this.getNumberAttribute('priority');
  }

  // project - computed: true, optional: false, required: false
  public get project() {
    return this.getStringAttribute('project');
  }

  // self_link - computed: true, optional: false, required: false
  public get selfLink() {
    return this.getStringAttribute('self_link');
  }

  // tags - computed: true, optional: false, required: false
  public get tags() {
    return this.getListAttribute('tags');
  }
}

/**
* Represents a {@link https://www.terraform.io/docs/providers/google/d/compute_router_status.html google_compute_router_status}
*/
export class DataGoogleComputeRouterStatus extends cdktf.TerraformDataSource {

  // =================
  // STATIC PROPERTIES
  // =================
  public static readonly tfResourceType: string = "google_compute_router_status";

  // ===========
  // INITIALIZER
  // ===========

  /**
  * Create a new {@link https://www.terraform.io/docs/providers/google/d/compute_router_status.html google_compute_router_status} Data Source
  *
  * @param scope The scope in which to define this construct
  * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
  * @param options DataGoogleComputeRouterStatusConfig
  */
  public constructor(scope: Construct, id: string, config: DataGoogleComputeRouterStatusConfig) {
    super(scope, id, {
      terraformResourceType: 'google_compute_router_status',
      terraformGeneratorMetadata: {
        providerName: 'google'
      },
      provider: config.provider,
      dependsOn: config.dependsOn,
      count: config.count,
      lifecycle: config.lifecycle
    });
    this._name = config.name;
    this._project = config.project;
    this._region = config.region;
  }

  // ==========
  // ATTRIBUTES
  // ==========

  // best_routes - computed: true, optional: false, required: false
  public bestRoutes(index: string) {
    return new DataGoogleComputeRouterStatusBestRoutes(this, 'best_routes', index);
  }

  // best_routes_for_router - computed: true, optional: false, required: false
  public bestRoutesForRouter(index: string) {
    return new DataGoogleComputeRouterStatusBestRoutesForRouter(this, 'best_routes_for_router', index);
  }

  // id - computed: true, optional: true, required: false
  public get id() {
    return this.getStringAttribute('id');
  }

  // name - computed: false, optional: false, required: true
  private _name?: string; 
  public get name() {
    return this.getStringAttribute('name');
  }
  public set name(value: string) {
    this._name = value;
  }
  // Temporarily expose input value. Use with caution.
  public get nameInput() {
    return this._name;
  }

  // network - computed: true, optional: false, required: false
  public get network() {
    return this.getStringAttribute('network');
  }

  // project - computed: false, optional: true, required: false
  private _project?: string; 
  public get project() {
    return this.getStringAttribute('project');
  }
  public set project(value: string) {
    this._project = value;
  }
  public resetProject() {
    this._project = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get projectInput() {
    return this._project;
  }

  // region - computed: true, optional: true, required: false
  private _region?: string; 
  public get region() {
    return this.getStringAttribute('region');
  }
  public set region(value: string) {
    this._region = value;
  }
  public resetRegion() {
    this._region = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get regionInput() {
    return this._region;
  }

  // =========
  // SYNTHESIS
  // =========

  protected synthesizeAttributes(): { [name: string]: any } {
    return {
      name: cdktf.stringToTerraform(this._name),
      project: cdktf.stringToTerraform(this._project),
      region: cdktf.stringToTerraform(this._region),
    };
  }
}
