// https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html
// generated from terraform resource schema

import { Construct } from 'constructs';
import * as cdktf from 'cdktf';

// Configuration

export interface DataGooglePrivatecaCertificateAuthorityConfig extends cdktf.TerraformMetaArguments {
  /**
  * The user provided Resource ID for this Certificate Authority.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html#certificate_authority_id DataGooglePrivatecaCertificateAuthority#certificate_authority_id}
  */
  readonly certificateAuthorityId?: string;
  /**
  * Location of the CertificateAuthority. A full list of valid locations can be found by
running 'gcloud privateca locations list'.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html#location DataGooglePrivatecaCertificateAuthority#location}
  */
  readonly location?: string;
  /**
  * The name of the CaPool this Certificate Authority belongs to.
  * 
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html#pool DataGooglePrivatecaCertificateAuthority#pool}
  */
  readonly pool?: string;
  /**
  * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html#project DataGooglePrivatecaCertificateAuthority#project}
  */
  readonly project?: string;
}
export class DataGooglePrivatecaCertificateAuthorityAccessUrls extends cdktf.ComplexComputedList {

  // ca_certificate_access_url - computed: true, optional: false, required: false
  public get caCertificateAccessUrl() {
    return this.getStringAttribute('ca_certificate_access_url');
  }

  // crl_access_urls - computed: true, optional: false, required: false
  public get crlAccessUrls() {
    return this.getListAttribute('crl_access_urls');
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigSubjectConfigSubject extends cdktf.ComplexComputedList {

  // common_name - computed: true, optional: false, required: false
  public get commonName() {
    return this.getStringAttribute('common_name');
  }

  // country_code - computed: true, optional: false, required: false
  public get countryCode() {
    return this.getStringAttribute('country_code');
  }

  // locality - computed: true, optional: false, required: false
  public get locality() {
    return this.getStringAttribute('locality');
  }

  // organization - computed: true, optional: false, required: false
  public get organization() {
    return this.getStringAttribute('organization');
  }

  // organizational_unit - computed: true, optional: false, required: false
  public get organizationalUnit() {
    return this.getStringAttribute('organizational_unit');
  }

  // postal_code - computed: true, optional: false, required: false
  public get postalCode() {
    return this.getStringAttribute('postal_code');
  }

  // province - computed: true, optional: false, required: false
  public get province() {
    return this.getStringAttribute('province');
  }

  // street_address - computed: true, optional: false, required: false
  public get streetAddress() {
    return this.getStringAttribute('street_address');
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigSubjectConfigSubjectAltName extends cdktf.ComplexComputedList {

  // dns_names - computed: true, optional: false, required: false
  public get dnsNames() {
    return this.getListAttribute('dns_names');
  }

  // email_addresses - computed: true, optional: false, required: false
  public get emailAddresses() {
    return this.getListAttribute('email_addresses');
  }

  // ip_addresses - computed: true, optional: false, required: false
  public get ipAddresses() {
    return this.getListAttribute('ip_addresses');
  }

  // uris - computed: true, optional: false, required: false
  public get uris() {
    return this.getListAttribute('uris');
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigSubjectConfig extends cdktf.ComplexComputedList {

  // subject - computed: true, optional: false, required: false
  public get subject() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('subject') as any;
  }

  // subject_alt_name - computed: true, optional: false, required: false
  public get subjectAltName() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('subject_alt_name') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigAdditionalExtensionsObjectId extends cdktf.ComplexComputedList {

  // object_id_path - computed: true, optional: false, required: false
  public get objectIdPath() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('object_id_path') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigAdditionalExtensions extends cdktf.ComplexComputedList {

  // critical - computed: true, optional: false, required: false
  public get critical() {
    return this.getBooleanAttribute('critical') as any;
  }

  // object_id - computed: true, optional: false, required: false
  public get objectId() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('object_id') as any;
  }

  // value - computed: true, optional: false, required: false
  public get value() {
    return this.getStringAttribute('value');
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigCaOptions extends cdktf.ComplexComputedList {

  // is_ca - computed: true, optional: false, required: false
  public get isCa() {
    return this.getBooleanAttribute('is_ca') as any;
  }

  // max_issuer_path_length - computed: true, optional: false, required: false
  public get maxIssuerPathLength() {
    return this.getNumberAttribute('max_issuer_path_length');
  }

  // non_ca - computed: true, optional: false, required: false
  public get nonCa() {
    return this.getBooleanAttribute('non_ca') as any;
  }

  // zero_max_issuer_path_length - computed: true, optional: false, required: false
  public get zeroMaxIssuerPathLength() {
    return this.getBooleanAttribute('zero_max_issuer_path_length') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigKeyUsageBaseKeyUsage extends cdktf.ComplexComputedList {

  // cert_sign - computed: true, optional: false, required: false
  public get certSign() {
    return this.getBooleanAttribute('cert_sign') as any;
  }

  // content_commitment - computed: true, optional: false, required: false
  public get contentCommitment() {
    return this.getBooleanAttribute('content_commitment') as any;
  }

  // crl_sign - computed: true, optional: false, required: false
  public get crlSign() {
    return this.getBooleanAttribute('crl_sign') as any;
  }

  // data_encipherment - computed: true, optional: false, required: false
  public get dataEncipherment() {
    return this.getBooleanAttribute('data_encipherment') as any;
  }

  // decipher_only - computed: true, optional: false, required: false
  public get decipherOnly() {
    return this.getBooleanAttribute('decipher_only') as any;
  }

  // digital_signature - computed: true, optional: false, required: false
  public get digitalSignature() {
    return this.getBooleanAttribute('digital_signature') as any;
  }

  // encipher_only - computed: true, optional: false, required: false
  public get encipherOnly() {
    return this.getBooleanAttribute('encipher_only') as any;
  }

  // key_agreement - computed: true, optional: false, required: false
  public get keyAgreement() {
    return this.getBooleanAttribute('key_agreement') as any;
  }

  // key_encipherment - computed: true, optional: false, required: false
  public get keyEncipherment() {
    return this.getBooleanAttribute('key_encipherment') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigKeyUsageExtendedKeyUsage extends cdktf.ComplexComputedList {

  // client_auth - computed: true, optional: false, required: false
  public get clientAuth() {
    return this.getBooleanAttribute('client_auth') as any;
  }

  // code_signing - computed: true, optional: false, required: false
  public get codeSigning() {
    return this.getBooleanAttribute('code_signing') as any;
  }

  // email_protection - computed: true, optional: false, required: false
  public get emailProtection() {
    return this.getBooleanAttribute('email_protection') as any;
  }

  // ocsp_signing - computed: true, optional: false, required: false
  public get ocspSigning() {
    return this.getBooleanAttribute('ocsp_signing') as any;
  }

  // server_auth - computed: true, optional: false, required: false
  public get serverAuth() {
    return this.getBooleanAttribute('server_auth') as any;
  }

  // time_stamping - computed: true, optional: false, required: false
  public get timeStamping() {
    return this.getBooleanAttribute('time_stamping') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigKeyUsageUnknownExtendedKeyUsages extends cdktf.ComplexComputedList {

  // object_id_path - computed: true, optional: false, required: false
  public get objectIdPath() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('object_id_path') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigKeyUsage extends cdktf.ComplexComputedList {

  // base_key_usage - computed: true, optional: false, required: false
  public get baseKeyUsage() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('base_key_usage') as any;
  }

  // extended_key_usage - computed: true, optional: false, required: false
  public get extendedKeyUsage() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('extended_key_usage') as any;
  }

  // unknown_extended_key_usages - computed: true, optional: false, required: false
  public get unknownExtendedKeyUsages() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('unknown_extended_key_usages') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509ConfigPolicyIds extends cdktf.ComplexComputedList {

  // object_id_path - computed: true, optional: false, required: false
  public get objectIdPath() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('object_id_path') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigX509Config extends cdktf.ComplexComputedList {

  // additional_extensions - computed: true, optional: false, required: false
  public get additionalExtensions() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('additional_extensions') as any;
  }

  // aia_ocsp_servers - computed: true, optional: false, required: false
  public get aiaOcspServers() {
    return this.getListAttribute('aia_ocsp_servers');
  }

  // ca_options - computed: true, optional: false, required: false
  public get caOptions() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('ca_options') as any;
  }

  // key_usage - computed: true, optional: false, required: false
  public get keyUsage() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('key_usage') as any;
  }

  // policy_ids - computed: true, optional: false, required: false
  public get policyIds() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('policy_ids') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityConfigA extends cdktf.ComplexComputedList {

  // subject_config - computed: true, optional: false, required: false
  public get subjectConfig() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('subject_config') as any;
  }

  // x509_config - computed: true, optional: false, required: false
  public get x509Config() {
    // Getting the computed value is not yet implemented
    return this.interpolationForAttribute('x509_config') as any;
  }
}
export class DataGooglePrivatecaCertificateAuthorityKeySpec extends cdktf.ComplexComputedList {

  // algorithm - computed: true, optional: false, required: false
  public get algorithm() {
    return this.getStringAttribute('algorithm');
  }

  // cloud_kms_key_version - computed: true, optional: false, required: false
  public get cloudKmsKeyVersion() {
    return this.getStringAttribute('cloud_kms_key_version');
  }
}

/**
* Represents a {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html google_privateca_certificate_authority}
*/
export class DataGooglePrivatecaCertificateAuthority extends cdktf.TerraformDataSource {

  // =================
  // STATIC PROPERTIES
  // =================
  public static readonly tfResourceType: string = "google_privateca_certificate_authority";

  // ===========
  // INITIALIZER
  // ===========

  /**
  * Create a new {@link https://www.terraform.io/docs/providers/google/d/privateca_certificate_authority.html google_privateca_certificate_authority} Data Source
  *
  * @param scope The scope in which to define this construct
  * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
  * @param options DataGooglePrivatecaCertificateAuthorityConfig = {}
  */
  public constructor(scope: Construct, id: string, config: DataGooglePrivatecaCertificateAuthorityConfig = {}) {
    super(scope, id, {
      terraformResourceType: 'google_privateca_certificate_authority',
      terraformGeneratorMetadata: {
        providerName: 'google'
      },
      provider: config.provider,
      dependsOn: config.dependsOn,
      count: config.count,
      lifecycle: config.lifecycle
    });
    this._certificateAuthorityId = config.certificateAuthorityId;
    this._location = config.location;
    this._pool = config.pool;
    this._project = config.project;
  }

  // ==========
  // ATTRIBUTES
  // ==========

  // access_urls - computed: true, optional: false, required: false
  public accessUrls(index: string) {
    return new DataGooglePrivatecaCertificateAuthorityAccessUrls(this, 'access_urls', index);
  }

  // certificate_authority_id - computed: false, optional: true, required: false
  private _certificateAuthorityId?: string; 
  public get certificateAuthorityId() {
    return this.getStringAttribute('certificate_authority_id');
  }
  public set certificateAuthorityId(value: string) {
    this._certificateAuthorityId = value;
  }
  public resetCertificateAuthorityId() {
    this._certificateAuthorityId = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get certificateAuthorityIdInput() {
    return this._certificateAuthorityId;
  }

  // config - computed: true, optional: false, required: false
  public config(index: string) {
    return new DataGooglePrivatecaCertificateAuthorityConfigA(this, 'config', index);
  }

  // create_time - computed: true, optional: false, required: false
  public get createTime() {
    return this.getStringAttribute('create_time');
  }

  // deletion_protection - computed: true, optional: false, required: false
  public get deletionProtection() {
    return this.getBooleanAttribute('deletion_protection') as any;
  }

  // desired_state - computed: true, optional: false, required: false
  public get desiredState() {
    return this.getStringAttribute('desired_state');
  }

  // gcs_bucket - computed: true, optional: false, required: false
  public get gcsBucket() {
    return this.getStringAttribute('gcs_bucket');
  }

  // id - computed: true, optional: true, required: false
  public get id() {
    return this.getStringAttribute('id');
  }

  // ignore_active_certificates_on_deletion - computed: true, optional: false, required: false
  public get ignoreActiveCertificatesOnDeletion() {
    return this.getBooleanAttribute('ignore_active_certificates_on_deletion') as any;
  }

  // key_spec - computed: true, optional: false, required: false
  public keySpec(index: string) {
    return new DataGooglePrivatecaCertificateAuthorityKeySpec(this, 'key_spec', index);
  }

  // labels - computed: true, optional: false, required: false
  public labels(key: string): string {
    return new cdktf.StringMap(this, 'labels').lookup(key);
  }

  // lifetime - computed: true, optional: false, required: false
  public get lifetime() {
    return this.getStringAttribute('lifetime');
  }

  // location - computed: false, optional: true, required: false
  private _location?: string; 
  public get location() {
    return this.getStringAttribute('location');
  }
  public set location(value: string) {
    this._location = value;
  }
  public resetLocation() {
    this._location = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get locationInput() {
    return this._location;
  }

  // name - computed: true, optional: false, required: false
  public get name() {
    return this.getStringAttribute('name');
  }

  // pem_ca_certificates - computed: true, optional: false, required: false
  public get pemCaCertificates() {
    return this.getListAttribute('pem_ca_certificates');
  }

  // pem_csr - computed: true, optional: false, required: false
  public get pemCsr() {
    return this.getStringAttribute('pem_csr');
  }

  // pool - computed: false, optional: true, required: false
  private _pool?: string; 
  public get pool() {
    return this.getStringAttribute('pool');
  }
  public set pool(value: string) {
    this._pool = value;
  }
  public resetPool() {
    this._pool = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get poolInput() {
    return this._pool;
  }

  // project - computed: false, optional: true, required: false
  private _project?: string; 
  public get project() {
    return this.getStringAttribute('project');
  }
  public set project(value: string) {
    this._project = value;
  }
  public resetProject() {
    this._project = undefined;
  }
  // Temporarily expose input value. Use with caution.
  public get projectInput() {
    return this._project;
  }

  // state - computed: true, optional: false, required: false
  public get state() {
    return this.getStringAttribute('state');
  }

  // type - computed: true, optional: false, required: false
  public get type() {
    return this.getStringAttribute('type');
  }

  // update_time - computed: true, optional: false, required: false
  public get updateTime() {
    return this.getStringAttribute('update_time');
  }

  // =========
  // SYNTHESIS
  // =========

  protected synthesizeAttributes(): { [name: string]: any } {
    return {
      certificate_authority_id: cdktf.stringToTerraform(this._certificateAuthorityId),
      location: cdktf.stringToTerraform(this._location),
      pool: cdktf.stringToTerraform(this._pool),
      project: cdktf.stringToTerraform(this._project),
    };
  }
}
